// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from novatel_gps_msgs:msg/ClockSteering.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__CLOCK_STEERING__STRUCT_HPP_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__CLOCK_STEERING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__novatel_gps_msgs__msg__ClockSteering __attribute__((deprecated))
#else
# define DEPRECATED__novatel_gps_msgs__msg__ClockSteering __declspec(deprecated)
#endif

namespace novatel_gps_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClockSteering_
{
  using Type = ClockSteering_<ContainerAllocator>;

  explicit ClockSteering_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->source = "";
      this->steering_state = "";
      this->period = 0ul;
      this->pulse_width = 0.0;
      this->bandwidth = 0.0;
      this->slope = 0.0f;
      this->offset = 0.0;
      this->drift_rate = 0.0;
    }
  }

  explicit ClockSteering_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : source(_alloc),
    steering_state(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->source = "";
      this->steering_state = "";
      this->period = 0ul;
      this->pulse_width = 0.0;
      this->bandwidth = 0.0;
      this->slope = 0.0f;
      this->offset = 0.0;
      this->drift_rate = 0.0;
    }
  }

  // field types and members
  using _source_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _source_type source;
  using _steering_state_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _steering_state_type steering_state;
  using _period_type =
    uint32_t;
  _period_type period;
  using _pulse_width_type =
    double;
  _pulse_width_type pulse_width;
  using _bandwidth_type =
    double;
  _bandwidth_type bandwidth;
  using _slope_type =
    float;
  _slope_type slope;
  using _offset_type =
    double;
  _offset_type offset;
  using _drift_rate_type =
    double;
  _drift_rate_type drift_rate;

  // setters for named parameter idiom
  Type & set__source(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->source = _arg;
    return *this;
  }
  Type & set__steering_state(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->steering_state = _arg;
    return *this;
  }
  Type & set__period(
    const uint32_t & _arg)
  {
    this->period = _arg;
    return *this;
  }
  Type & set__pulse_width(
    const double & _arg)
  {
    this->pulse_width = _arg;
    return *this;
  }
  Type & set__bandwidth(
    const double & _arg)
  {
    this->bandwidth = _arg;
    return *this;
  }
  Type & set__slope(
    const float & _arg)
  {
    this->slope = _arg;
    return *this;
  }
  Type & set__offset(
    const double & _arg)
  {
    this->offset = _arg;
    return *this;
  }
  Type & set__drift_rate(
    const double & _arg)
  {
    this->drift_rate = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t INTERNAL_SOURCE =
    0;
  static constexpr int8_t EXTERNAL_SOURCE =
    1;
  static constexpr int8_t FIRST_ORDER_STEERING_STATE =
    0;
  static constexpr int8_t SECOND_ORDER_STEERING_STATE =
    1;
  static constexpr int8_t CALIBRATE_HIGH_STEERING_STATE =
    2;
  static constexpr int8_t CALIBRATE_LOW_STEERING_STATE =
    3;
  static constexpr int8_t CALIBRATE_CENTER_STEERING_STATE =
    4;

  // pointer types
  using RawPtr =
    novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator> *;
  using ConstRawPtr =
    const novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__novatel_gps_msgs__msg__ClockSteering
    std::shared_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__novatel_gps_msgs__msg__ClockSteering
    std::shared_ptr<novatel_gps_msgs::msg::ClockSteering_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClockSteering_ & other) const
  {
    if (this->source != other.source) {
      return false;
    }
    if (this->steering_state != other.steering_state) {
      return false;
    }
    if (this->period != other.period) {
      return false;
    }
    if (this->pulse_width != other.pulse_width) {
      return false;
    }
    if (this->bandwidth != other.bandwidth) {
      return false;
    }
    if (this->slope != other.slope) {
      return false;
    }
    if (this->offset != other.offset) {
      return false;
    }
    if (this->drift_rate != other.drift_rate) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClockSteering_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClockSteering_

// alias to use template instance with default allocator
using ClockSteering =
  novatel_gps_msgs::msg::ClockSteering_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::INTERNAL_SOURCE;
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::EXTERNAL_SOURCE;
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::FIRST_ORDER_STEERING_STATE;
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::SECOND_ORDER_STEERING_STATE;
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::CALIBRATE_HIGH_STEERING_STATE;
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::CALIBRATE_LOW_STEERING_STATE;
template<typename ContainerAllocator>
constexpr int8_t ClockSteering_<ContainerAllocator>::CALIBRATE_CENTER_STEERING_STATE;

}  // namespace msg

}  // namespace novatel_gps_msgs

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__CLOCK_STEERING__STRUCT_HPP_
